SystemOrganization addCategory: #'DAO-Satellite'!

Object subclass: #Beacon
	instanceVariableNames: 'data subsystemsOrderedById'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!Beacon class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 13:03'!
newFromSubsystems: subsystems 
	^ self new initializeFromSubsystems: subsystems
! !

!Beacon methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 15:20'!
collectTelemetry

	data :=  subsystemsOrderedById collect: [ :subsystem | subsystem telemetry ].

	^ data.
! !

!Beacon methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 11:59'!
data
	^ data! !

!Beacon methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 15:05'!
initializeFromSubsystems: subsystems
	subsystemsOrderedById := SortedCollection sortBlock: [ :current :new | current id < new id ].

	subsystemsOrderedById addAll: subsystems.		

	self collectTelemetry.
! !

Beacon subclass: #ShortBeacon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ShortBeacon methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 15:20'!
collectTelemetry
	
	data := subsystemsOrderedById collect: [ :subsystem | subsystem shortTelemetry ].
	
	^ data.
! !

Object subclass: #Command
	instanceVariableNames: 'id parameters responseParameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

Command subclass: #CDHDelayBeaconCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!CDHDelayBeaconCommand methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/29/2013 20:15'!
initialize

	id := 32.
	self initializeCommandDefinition.! !

!CDHDelayBeaconCommand methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/29/2013 20:18'!
initializeCommandDefinition
	| parameter |
	parameters := OrderedCollection new.
	parameter := UnsignedIntegerCommandParameter new: 16.
	parameters add: parameter.
	responseParameters := OrderedCollection new.! !

Command subclass: #CDHGetRadioCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

Command subclass: #CDHSetBeaconDataCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

Command subclass: #CDHSetBeaconIntervalSecondsCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

Command subclass: #CDHSetRadioConfigCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

Command subclass: #CDHSetTxPowerCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

Command subclass: #CDHShortTelemetryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!CDHShortTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 18:14'!
initialize 
	id := 2.
	self initializeCommandDefinition

! !

!CDHShortTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 18:14'!
initializeCommandDefinition
	parameters := OrderedCollection new.
	responseParameters := OrderedCollection new.
	
	responseParameters add: (UnsignedIntegerCommandParameter new: 8).
! !

Command subclass: #CDHTelemetryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!CDHTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 18:15'!
initialize 
	id := 1.
	self initializeCommandDefinition

! !

!CDHTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 18:15'!
initializeCommandDefinition
	parameters := OrderedCollection new.
	responseParameters := OrderedCollection new.
	
	responseParameters add: (UnsignedIntegerCommandParameter new: 32).
	responseParameters add: (UnsignedIntegerCommandParameter new: 32).
	responseParameters add: (UnsignedIntegerCommandParameter new: 8).
! !

!Command methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 17:14'!
= aCommand
	^ id = aCommand id! !

!Command methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 13:03'!
addParameterValue: aValue
	| parameter |
	
	parameter := parameters at: (parameters findFirst: [ :p | (p value) isNil]).
	
	parameter value: aValue.
! !

!Command methodsFor: 'deserialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 19:34'!
deserializeResponse: serializedResponse 

	| responseData readStream |

	responseParameters isEmpty ifTrue: [ ^VoidCommandResponse new. ].
		
	"discard first 3 bytes of sequence number"
	readStream := ReadStream on: (serializedResponse allButFirst: 3).

	responseData := OrderedCollection new.

	responseParameters do: [ :parameter | responseData add: (parameter deserialize: readStream)].
	
	^ DataCommandResponse newWithData: responseData.
! !

!Command methodsFor: 'executing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 19:22'!
executeOn: aSubsystem
	^ self subclassResponsibility.! !

!Command methodsFor: 'accessing' stamp: 'EzequielDavidovichCaballero 9/15/2013 17:46'!
id
	^ id! !

!Command methodsFor: 'initialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 17:46'!
initialize
	parameters := OrderedCollection new.
	responseParameters := OrderedCollection new.
	self initializeCommandDefinition ! !

!Command methodsFor: 'initialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 17:47'!
initializeCommandDefinition
	self subclassResponsibility.! !

!Command methodsFor: 'serialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/28/2013 11:57'!
serialize
	
	| stream |
			
	stream := WriteStream on: ByteArray new.
		
	stream nextPut: (id asByte).

	parameters do: [ :parameter |
		stream nextPutAll: (parameter serialize).
	].
	
	^ stream contents.! !

Command subclass: #GetNameCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!GetNameCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 19:34'!
executeOn: aSubsystem
	| data |
	
	data := OrderedCollection new.
	data add: aSubsystem name.
	
	^ DataCommandResponse newWithData: data.! !

!GetNameCommand methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/29/2013 16:49'!
initialize

	id := 0.
	self initializeCommandDefinition.! !

!GetNameCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 19:45'!
initializeCommandDefinition
	parameters := OrderedCollection new.
		
	responseParameters := OrderedCollection new.
	responseParameters add: StringCommandParameter new.
! !

Command subclass: #MemoryReadAddressCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!MemoryReadAddressCommand methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/29/2013 17:50'!
initialize

	id := 32.
	self initializeCommandDefinition.! !

!MemoryReadAddressCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:08'!
initializeCommandDefinition
	parameters := OrderedCollection new.
	parameters add: (UnsignedIntegerCommandParameter new: 32).
	
	responseParameters := OrderedCollection new.
	responseParameters add: (ArrayCommandParameter newWithElementType: UnsignedIntegerCommandParameter andElementSize: 8 andLength: 200).
! !

Command subclass: #MemoryReadChunkedAddressCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!MemoryReadChunkedAddressCommand methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/29/2013 17:50'!
initialize

	id := 45.
	self initializeCommandDefinition.
	
	responseParameters := OrderedCollection new.! !

!MemoryReadChunkedAddressCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 16:14'!
initializeCommandDefinition
	| parameter |
	parameters := OrderedCollection new.
	
	parameter := UnsignedIntegerCommandParameter new: 32.
	parameters add: parameter.
	
	parameter := UnsignedIntegerCommandParameter new: 32.
	parameters add: parameter.
	
	parameter := UnsignedIntegerCommandParameter new: 32.
	parameters add: parameter.
	
	parameter := UnsignedIntegerCommandParameter new: 32.
	parameters add: parameter.
	
	parameter := UnsignedIntegerCommandParameter new: 32.
	parameters add: parameter.
	
	responseParameters := OrderedCollection new.! !

Command subclass: #MemoryReadLongAddressCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!MemoryReadLongAddressCommand methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/29/2013 17:50'!
initialize

	id := 44.
	self initializeCommandDefinition.
! !

!MemoryReadLongAddressCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:14'!
initializeCommandDefinition
	| parameter |
	parameters := OrderedCollection new.
	
	parameter := UnsignedIntegerCommandParameter new: 32.
	parameters add: parameter.
	
	parameter := UnsignedIntegerCommandParameter new: 32.
	parameters add: parameter.

	responseParameters := OrderedCollection new.
	responseParameters add: (UnsignedIntegerCommandParameter new: 32).
	responseParameters add: (ArrayCommandParameter newWithElementType: UnsignedIntegerCommandParameter andElementSize: 8 andLength: 200).
! !

Command subclass: #MemoryShortTelemetryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!MemoryShortTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 18:17'!
initialize
	id := 2.
	self initializeCommandDefinition
! !

!MemoryShortTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 17:36'!
initializeCommandDefinition
	parameters := OrderedCollection new.
	responseParameters := OrderedCollection new.
! !

Command subclass: #MemoryTelemetryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!MemoryTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 18:16'!
initialize
	id := 1.
	self initializeCommandDefinition
! !

!MemoryTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 18:01'!
initializeCommandDefinition
	parameters := OrderedCollection new.
	responseParameters := OrderedCollection new.
	
	responseParameters add: (UnsignedIntegerCommandParameter new: 32).
! !

Command subclass: #MemoryWriteAddressCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!MemoryWriteAddressCommand methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/29/2013 17:50'!
initialize

	id := 33.
	self initializeCommandDefinition.! !

!MemoryWriteAddressCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 16:13'!
initializeCommandDefinition
	| parameter |
	parameters := OrderedCollection new.
	
	parameter := UnsignedIntegerCommandParameter new: 32.
	parameters add: parameter.
	
	parameter := StringCommandParameter new: 8.
	parameters add: parameter.

	responseParameters := OrderedCollection new.! !

Command subclass: #PlatformResetCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

Command subclass: #PlatformSetModeCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!PlatformSetModeCommand methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/29/2013 17:51'!
initialize

	id := 32.
	self initializeCommandDefinition.! !

!PlatformSetModeCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 16:13'!
initializeCommandDefinition
	| parameter |
	parameters := OrderedCollection new.
	
	parameter := UnsignedIntegerCommandParameter new: 8.
	parameters add: parameter.

	responseParameters := OrderedCollection new.! !

Command subclass: #PlatformShortTelemetryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!PlatformShortTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 18:07'!
initialize
	id := 2.
	self initializeCommandDefinition.! !

!PlatformShortTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 17:37'!
initializeCommandDefinition
	parameters := OrderedCollection new.
	responseParameters := OrderedCollection new.
! !

Command subclass: #PlatformShortTelemetrycommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

Command subclass: #PlatformTelemetryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!PlatformTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 18:05'!
initialize
	id := 1.
	self initializeCommandDefinition.
! !

!PlatformTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 18:06'!
initializeCommandDefinition
	parameters := OrderedCollection new.
	responseParameters := OrderedCollection new.

	responseParameters add: (UnsignedIntegerCommandParameter new: 64).
	responseParameters add: (UnsignedIntegerCommandParameter new: 8).! !

Command subclass: #PlatformTelemetrycommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

Command subclass: #PlatformVersionCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

Command subclass: #PowerResetCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

Command subclass: #PowerShortTelemetryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!PowerShortTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 18:08'!
initialize
	id := 2.
	self initializeCommandDefinition.
! !

!PowerShortTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 17:37'!
initializeCommandDefinition
	parameters := OrderedCollection new.
	responseParameters := OrderedCollection new.
! !

Command subclass: #PowerStbGetSwitchesStateCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

Command subclass: #PowerStbSetInitialStateCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

Command subclass: #PowerStbSetSwitchesStateCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!PowerStbSetSwitchesStateCommand methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/29/2013 17:51'!
initialize

	
	id := 36.
	self initializeCommandDefinition.! !

!PowerStbSetSwitchesStateCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 16:13'!
initializeCommandDefinition
	| parameter |
	parameters := OrderedCollection new.
	
	parameter := UnsignedIntegerCommandParameter new: 24.
	parameters add: parameter.
	
	responseParameters := OrderedCollection new.! !

Command subclass: #PowerTelemetryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!PowerTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 18:09'!
initialize
	id := 1.
	self initializeCommandDefinition.
! !

!PowerTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 18:13'!
initializeCommandDefinition
	parameters := OrderedCollection new.
	responseParameters := OrderedCollection new.

	13 timesRepeat: [ 
		responseParameters add: (UnsignedIntegerCommandParameter new: 16). 
	]
! !

Command subclass: #PowerTelemetrycommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

Command subclass: #ThermalSetMatrixKeyCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ThermalSetMatrixKeyCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 19:22'!
executeOn: aSubsystem

	aSubsystem setMatrixKey: ((parameters at: 1) value).
	
	^ VoidCommandResponse new.
	! !

!ThermalSetMatrixKeyCommand methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/29/2013 17:51'!
initialize

	id := 32.
	self initializeCommandDefinition.! !

!ThermalSetMatrixKeyCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 16:13'!
initializeCommandDefinition
	| parameter |
	
	parameters := OrderedCollection new.
	
	parameter := UnsignedIntegerCommandParameter new: 32.
	parameters add: parameter.


	responseParameters := OrderedCollection new.! !

Command subclass: #ThermalShortTelemetryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ThermalShortTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/29/2013 16:52'!
initialize

	id := 2.
	self initializeCommandDefinition! !

!ThermalShortTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 18:16'!
initializeCommandDefinition
	parameters := OrderedCollection new.
	responseParameters := OrderedCollection new.

	responseParameters add: (UnsignedIntegerCommandParameter new: 8).
! !

Command subclass: #ThermalTelemetryCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ThermalTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/29/2013 16:52'!
initialize

	id := 1.
	self initializeCommandDefinition! !

!ThermalTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 18:02'!
initializeCommandDefinition 
	parameters := OrderedCollection new.
	responseParameters := OrderedCollection new.
	
	responseParameters add: (SignedIntegerCommandParameter new: 16).
	responseParameters add: (SignedIntegerCommandParameter new: 16).

! !

!ThermalTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 15:15'!
initializeParametersDefinition 
	parameters := OrderedCollection new.
! !

!ThermalTelemetryCommand methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 15:16'!
initializeResponseParametersDefinition 
	| parameter |

	responseParameters := OrderedCollection new.

	parameter := SignedIntegerCommandParameter new: 16.
	responseParameters add: parameter.

	parameter := SignedIntegerCommandParameter new: 16.
	responseParameters add: parameter.
! !

Object subclass: #CommandParameter
	instanceVariableNames: 'value bitSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

CommandParameter subclass: #ArrayCommandParameter
	instanceVariableNames: 'type arrayLength elementSize elementType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ArrayCommandParameter class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:08'!
newWithElementType: type andElementSize: elementSize andLength: arrayLength
	^ self new initializeWithElementType: type andElementSize: elementSize andArrayLength: arrayLength.
	! !

!ArrayCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:06'!
deserialize: aReadStream 
	| result responseParameter |
	
	result := OrderedCollection new.
	
	[aReadStream atEnd] whileFalse: [ 
		" create an object of type elementType (i.e. UnsignedIntegerCommandParameter) and size in bits elementSize"
		responseParameter := elementType new: elementSize.
		value := responseParameter deserialize: aReadStream.
		result add: value.
	 ].

	^ result.! !

!ArrayCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 17:51'!
elementSize
	^ elementSize! !

!ArrayCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:07'!
initializeWithElementType: theType andElementSize: theElementSize andArrayLength: theArrayLength
	elementType := theType.
	elementSize := theElementSize.
	arrayLength := theArrayLength.! !

!CommandParameter class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 16:03'!
new: aSize
	^ self new initializeWithBitSize: aSize! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 16:04'!
byteSize
	^ (bitSize / 8)! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 16:04'!
initializeWithBitSize: aSize
	bitSize := aSize! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 14:22'!
value
	^ value! !

!CommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 14:22'!
value: aValue
	value := aValue! !

CommandParameter subclass: #SignedIntegerCommandParameter
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!SignedIntegerCommandParameter methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/28/2013 18:21'!
deserialize: aReadstream 
	| serializedValue sign result |
	
	"take first 2 bytes from the input, first byte is sign"

	sign := aReadstream next asInteger.
	serializedValue := aReadstream next.
	result := serializedValue asInteger.
	
	(sign = 1) ifTrue: [ result := result * -1].
	
	^ result.! !

CommandParameter subclass: #StringCommandParameter
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!StringCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 19:49'!
deserialize: aReadStream 

	^ aReadStream contents asString.
! !

!StringCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 14:24'!
serialize 

	| valueBytes valueSize headerSize header result stream |

	valueBytes := value asByteArray.
	valueSize := valueBytes size.

	headerSize := (self byteSize).	
	header := ByteArray new: headerSize.
	header replaceFrom: (headerSize - (valueSize asByteArray size) + 1) to: headerSize with: (valueSize asByteArray).
	
	result := ByteArray new: headerSize + valueSize.
	stream := WriteStream on: result.
	stream nextPutAll: header.
	stream nextPutAll: valueBytes.

	^ result.
! !

CommandParameter subclass: #UnsignedIntegerCommandParameter
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!UnsignedIntegerCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/22/2013 18:02'!
deserialize: aReadstream 
	| serializedValue |
	
	serializedValue := aReadstream next: (self byteSize).
	
	^ serializedValue asInteger.
! !

!UnsignedIntegerCommandParameter methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 14:24'!
serialize

	| valueBytes start stop result |
	
	result := ByteArray new: (self byteSize).
	
	valueBytes := value asByteArray.
	start := (result size) - (valueBytes size) + 1.
	stop := (result size).
	result replaceFrom: start to: stop with: valueBytes.
	
	^ result.
! !

Object subclass: #CommandResponse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!CommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 19:37'!
data
	self subclassResponsibility! !

CommandResponse subclass: #DataCommandResponse
	instanceVariableNames: 'data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!DataCommandResponse class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 20:23'!
newWithData: data
	^ self new initializeWithData: data.! !

!DataCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 19:38'!
= aResponse
	^ data = aResponse data! !

!DataCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 20:28'!
data
	^ data! !

!DataCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 20:24'!
initializeWithData: aData
	data := aData! !

CommandResponse subclass: #VoidCommandResponse
	instanceVariableNames: 'code'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!VoidCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 19:17'!
= anotherResponse
	^ anotherResponse isKindOf: VoidCommandResponse! !

!VoidCommandResponse methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 19:38'!
data
	^ OrderedCollection new.! !

Object subclass: #ControllerLog
	instanceVariableNames: 'entries archive'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!ControllerLog class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 20:13'!
newWithArchive: aLogArchive 
	^ self new initializeWithArchive: aLogArchive.! !

!ControllerLog methodsFor: 'recording' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 22:51'!
addRequest: aRequest withSequenceNumber: aSequenceNumber
	| entry |

	(self containsEntryWithSequenceNumber: aSequenceNumber) ifTrue: [
		entry := self entryWithSequenceNumber: aSequenceNumber.
		self archive: entry. ].
	
	entry := ControllerLogEntry newWithRequest: aRequest andSequenceNumber: aSequenceNumber.
	
	entries at: aSequenceNumber put: entry.
! !

!ControllerLog methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 22:21'!
addResponse: aResponse withSequenceNumber: aSequenceNumber
	| logEntry |

	logEntry := entries at: aSequenceNumber.

	logEntry setResponse: aResponse.
	! !

!ControllerLog methodsFor: 'recording' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 23:12'!
archive
	^ archive! !

!ControllerLog methodsFor: 'recording' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 23:12'!
archive: anEntry
	archive add: anEntry.! !

!ControllerLog methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 22:51'!
containsEntryWithSequenceNumber: aNumber 
	[entries at: aNumber] on: KeyNotFound do: [ ^ false ].
	^ true.! !

!ControllerLog methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 20:15'!
entryWithSequenceNumber: aSequenceNumber 
	^ entries at: aSequenceNumber.! !

!ControllerLog methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 23:12'!
initialize
	entries := Dictionary new.
	archive := LinkedList new.! !

Object subclass: #ControllerLogEntry
	instanceVariableNames: 'sequenceNumber request time response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

ControllerLogEntry class
	instanceVariableNames: 'time sequenceNumber request'!

ControllerLogEntry class
	instanceVariableNames: 'time sequenceNumber request'!

!ControllerLogEntry class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 20:46'!
newWithRequest: aRequest andSequenceNumber: aSequenceNumber
	^ self new initializeWithRequest: aRequest andSequenceNumber: aSequenceNumber.! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 20:34'!
initializeWithRequest: aRequest andSequenceNumber: aSequenceNumber
	time := DateAndTime now.
	request := aRequest.
	sequenceNumber := aSequenceNumber.! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 20:42'!
request
	^ request
! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 22:20'!
response
	^ response! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 22:21'!
setResponse: aResponse
	response := aResponse.! !

!ControllerLogEntry methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/17/2013 20:35'!
time
	^ time! !

Object subclass: #MacGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

MacGenerator subclass: #MD5MacGenerator
	instanceVariableNames: 'sequenceNumber serializedCommandCall'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!MD5MacGenerator class methodsFor: 'key' stamp: 'NahuelGarbezza 5/18/2013 09:41'!
key

	"
	'Generate a random binary key' asByteArray adding 16r00 up to 32 len
	"
	
	^ #[71 101 110 101 114 97 116 101 32 97 32 114 97 110 100 111 109 32 98 105 110 97 114 121 32 107 101 121 00 00 00 00]! !

!MD5MacGenerator methodsFor: 'initialization' stamp: 'HernanWilkinson 3/25/2013 14:54'!
initializeFor: aSerializedCommandCall with: aSequenceNumber

	serializedCommandCall := aSerializedCommandCall.
	sequenceNumber := aSequenceNumber.
! !

!MD5MacGenerator methodsFor: 'evaluating - private' stamp: 'HernanWilkinson 3/25/2013 15:36'!
macFrom: md5

	| mac |
	
	mac := md5 first: 3.
	mac swap: 1 with: 3.
	^ mac! !

!MD5MacGenerator methodsFor: 'evaluating - private' stamp: 'NahuelGarbezza 5/18/2013 09:40'!
md5For: aStream

	aStream reset.
	^ MD5 hashStream: aStream! !

!MD5MacGenerator methodsFor: 'evaluating - private' stamp: 'NahuelGarbezza 5/18/2013 09:41'!
streamToCalculateMD5

	| stream |
	stream := ReadWriteStream on: ByteArray new.
	stream
		nextPutAll: self key;
		nextPut: (sequenceNumber bitAnd: 16rFF);
		nextPut: ((sequenceNumber digitAt: 2) bitAnd: 16rFF);
		nextPut: ((sequenceNumber digitAt: 3) bitAnd: 16rFF);
		nextPut: ((sequenceNumber digitAt: 4) bitAnd: 16rFF);
		nextPutAll: serializedCommandCall.
	^ stream! !

!MD5MacGenerator methodsFor: 'evaluating' stamp: 'HernanWilkinson 3/25/2013 15:21'!
value

	| stream md5 mac |
	
	stream := self streamToCalculateMD5.
	md5 := self md5For: stream.
	mac := self macFrom: md5.
	
	^ mac
	! !

!MacGenerator class methodsFor: 'instance creation' stamp: 'NahuelGarbezza 5/18/2013 09:41'!
for: aSerializedCommandCall with: aSequenceNumber

	^ self new initializeFor: aSerializedCommandCall with: aSequenceNumber! !

!MacGenerator class methodsFor: 'key' stamp: 'HernanWilkinson 3/25/2013 14:57'!
key

	self subclassResponsibility ! !

!MacGenerator methodsFor: 'initialization' stamp: 'HernanWilkinson 3/25/2013 14:53'!
initializeFor: aSerializedCommandCall with: aSequenceNumber 

	self subclassResponsibility ! !

!MacGenerator methodsFor: 'evaluating' stamp: 'NahuelGarbezza 5/18/2013 09:40'!
key

	^ self class key! !

!MacGenerator methodsFor: 'evaluating' stamp: 'HernanWilkinson 3/25/2013 14:53'!
value

	self subclassResponsibility ! !

Object subclass: #Satellite
	instanceVariableNames: 'subsystems'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!Satellite class methodsFor: 'instance creation' stamp: 'EmilianoMenendez 9/7/2013 16:27'!
newWithSubsystems: theSubsystems 
	^ self new initalizeWithSubsystems: theSubsystems! !

!Satellite methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 19:02'!
commandWithId: aCommandId andSubsystemId: aSubsystemId
	| subsystem |
	
	subsystem := self subsystemWithId: aSubsystemId.
	
	aCommandId = 0 ifTrue: [ ^ GetNameCommand new. ].
! !

!Satellite methodsFor: 'messaging' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 13:02'!
emitBeacon
	^ Beacon newFromSubsystems: subsystems.
! !

!Satellite methodsFor: 'messaging' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 15:13'!
emitShortBeacon
	^ ShortBeacon newFromSubsystems: subsystems.

	
	! !

!Satellite methodsFor: 'initialization' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/21/2013 16:11'!
initalizeWithSubsystems: theSubsystems

	subsystems := theSubsystems.


! !

!Satellite methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 17:29'!
receive: aByteArray 
	| readStream sequence subsystemId commandId command |
	
	readStream := ReadStream on: aByteArray.

	"discard MAC"
	readStream next: 3.
	
	sequence := (readStream next: 3) asInteger.
	subsystemId := readStream next asInteger.
	commandId := readStream next asInteger.
	
	command := self commandWithId: commandId andSubsystemId: subsystemId.
	
	"TODO: read parameters from stream and set them into the command"
	
	^ command.
! !

!Satellite methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 17:23'!
subsystemWithId: aSubsystemId
	^ subsystems detect: [ :subsystem | subsystem id = aSubsystemId ].
! !

!Satellite methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 19:59'!
subsystems
	
	^ subsystems
! !

Object subclass: #SatelliteController
	instanceVariableNames: 'radioStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!SatelliteController methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/28/2013 19:34'!
decode: aByteArray ! !

!SatelliteController methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 18:58'!
encode: aCommand forSubsystem: subsystem withSequenceNumber: aSequenceNumber
	| subsystemId encodedCommand encodedBytes stream sequenceNumberByteArray sequenceNumberParameter macGenerator mac |

	subsystemId := subsystem id.

	encodedCommand := aCommand serialize.

	macGenerator := MD5MacGenerator for: encodedCommand with: aSequenceNumber.
	mac := macGenerator value.
		
	sequenceNumberParameter := UnsignedIntegerCommandParameter new: 24.
	sequenceNumberParameter value: (aSequenceNumber number).
	
	sequenceNumberByteArray := sequenceNumberParameter serialize.
	
	encodedBytes := ByteArray new: (mac asByteArray size) + (sequenceNumberByteArray size) + (subsystemId asByteArray size) + (encodedCommand size).
	
	stream := WriteStream on: encodedBytes.
	
	stream nextPutAll: mac asByteArray.
	stream nextPutAll: sequenceNumberByteArray.
	stream nextPutAll: subsystemId asByteArray.
	stream nextPutAll: encodedCommand.
	
	^ encodedBytes.! !

!SatelliteController methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 18:54'!
initialize 
	"radioStream := SocketStream openConnectionToHostNamed: 'localhost' port: 4445.
	radioStream binary."! !

!SatelliteController methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/24/2013 23:11'!
radioStream
	^ radioStream
! !

!SatelliteController methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/24/2013 23:10'!
shutdown 
	radioStream close.
! !

Object subclass: #SatelliteSubsystem
	instanceVariableNames: 'id data telemetryKeys shortTelemetryKeys name commands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

!SatelliteSubsystem class methodsFor: 'instantiation' stamp: 'EzequielDavidovichCaballero 10/2/2013 15:56'!
cdh
	| shortTkeys tKeys cmds |
	
	tKeys := Set new.
	tKeys add: 'lastSeenSequenceNumber'.
	tKeys add: 'nextBeaconEnableTicks'.
	tKeys add: 'antennaDeployStatus'.
	
	shortTkeys := Set new.
	shortTkeys add: 'ticksLow'.
	
	cmds:= Dictionary new.
	cmds at: 'name' put: GetNameCommand.
	cmds at: 'telemetry' put: CDHTelemetryCommand.
	cmds at: 'short_telemetry' put: CDHShortTelemetryCommand.
	cmds at: 'delay_beaconSeconds' put: CDHDelayBeaconCommand.
	cmds at: 'set_beacon_intervalSeconds' put: CDHSetBeaconIntervalSecondsCommand.
	cmds at: 'set_tx_powerr' put: CDHSetTxPowerCommand.
	cmds at: 'set_beaconData' put: CDHSetBeaconDataCommand.
	cmds at: 'get_radio' put: CDHGetRadioCommand.
	cmds at: 'set_radioConfig' put: CDHSetRadioConfigCommand.
	

	^self new initializeWithId: 3 andName: 'THERMAL' andTelemetryKeys: tKeys andShortTelemetryKeys: shortTkeys andCommands: Dictionary new.
! !

!SatelliteSubsystem class methodsFor: 'instantiation' stamp: 'EzequielDavidovichCaballero 10/2/2013 15:56'!
memory
	
	|tKeys shortTKeys cmds |
	
	tKeys := Set new.
	tKeys add: 'free'.
	
	shortTKeys := Set new.

	cmds := Dictionary new.
	cmds at: 'name' put: GetNameCommand.
	cmds at: 'telemetry' put: MemoryTelemetryCommand.
	cmds at: 'short_telemetry' put: MemoryShortTelemetryCommand.
	cmds at: 'readAdress' put: MemoryReadAddressCommand.
	
 	^self new initializeWithId: 1 andName: 'MEMORY' andTelemetryKeys: tKeys andShortTelemetryKeys: shortTKeys andCommands: cmds.! !

!SatelliteSubsystem class methodsFor: 'instantiation' stamp: 'EzequielDavidovichCaballero 10/2/2013 15:56'!
platform

	| tKeys shortTKeys cmds |
	
	tKeys := Set new.
	tKeys add: 'tick_count'.
	tKeys add: 'current_mode'.
	
	shortTKeys := Set new.
	
	cmds:= Dictionary new.
	cmds at: 'name' put: GetNameCommand.
	cmds at: 'telemetry' put: PlatformTelemetryCommand.
	cmds at: 'short_telemetry' put: PlatformShortTelemetryCommand.
	cmds at: 'setMode' put: PlatformSetModeCommand.
	cmds at: 'reset' put: PlatformResetCommand.
	cmds at: 'version' put: PlatformVersionCommand.
	
	^self new initializeWithId: 0 andName: 'PLATFORM' andTelemetryKeys: tKeys andShortTelemetryKeys: shortTKeys andCommands: cmds.! !

!SatelliteSubsystem class methodsFor: 'instantiation' stamp: 'EzequielDavidovichCaballero 10/2/2013 15:56'!
power

	| tKeys shortTKeys cmds |
	
	tKeys := Set new.
	tKeys add: 'tick_count'.
	tKeys add: 'current_mode'.
	
	shortTKeys := Set new.
	
	cmds:= Dictionary new.
	cmds at: 'name' put: GetNameCommand.
	cmds at: 'telemetry' put: PlatformTelemetryCommand.
	cmds at: 'short_telemetry' put: PlatformShortTelemetryCommand.
	cmds at: 'setMode' put: PlatformSetModeCommand.
	cmds at: 'reset' put: PlatformResetCommand.
	cmds at: 'version' put: PlatformVersionCommand.
	
	^self new initializeWithId: 0 andName: 'PLATFORM' andTelemetryKeys: tKeys andShortTelemetryKeys: shortTKeys andCommands: cmds.! !

!SatelliteSubsystem class methodsFor: 'instantiation' stamp: 'EzequielDavidovichCaballero 10/2/2013 15:56'!
thermal

	| cmds shortTkeys tKeys |
	
	tKeys := Set new.
	tKeys add: 'battery_temp'.
	tKeys add: 'radio_temp'.
	
	shortTkeys := Set new.
	shortTkeys add: 'battery_temp'.
	
	cmds := Dictionary new.
	cmds at: 'name' put: GetNameCommand.
	cmds at: 'telemetry' put: ThermalTelemetryCommand.
	cmds at: 'short_telemetry' put: ThermalShortTelemetryCommand.
	cmds at: 'setMatrixKey' put: ThermalSetMatrixKeyCommand.
	
	
	^self new initializeWithId: 3 andName: 'THERMAL' andTelemetryKeys: tKeys andShortTelemetryKeys: shortTkeys andCommands: cmds.
	
! !

!SatelliteSubsystem methodsFor: 'command' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/14/2013 16:35'!
= anObject
	^ id = anObject id! !

!SatelliteSubsystem methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 18:27'!
commands
	^ commands! !

!SatelliteSubsystem methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/14/2013 16:03'!
getValueOfAttribute: aKey
	^ (data at: aKey)! !

!SatelliteSubsystem methodsFor: 'accessing' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 16:10'!
id
	^ id! !

!SatelliteSubsystem methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/28/2013 21:27'!
initializeWithId: theId andName: theName andTelemetryKeys: theTelemetryKeys andShortTelemetryKeys: theShortTelemetryKeys andCommands: theCommands
	id := theId.
	name := theName.
	commands := theCommands.
	telemetryKeys := theTelemetryKeys.
	shortTelemetryKeys := theShortTelemetryKeys.
	data := Dictionary new.! !

!SatelliteSubsystem methodsFor: 'command' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/9/2013 16:11'!
name
	^ name! !

!SatelliteSubsystem methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/14/2013 12:46'!
setAttribute: aKey withValue: aValue 
	data at: aKey put: aValue! !

!SatelliteSubsystem methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/2/2013 16:05'!
setMatrixKey: theValue
	data at: 'matrix_key' put: theValue! !

!SatelliteSubsystem methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 10/2/2013 16:05'!
setMode: theValue
	data at: 'current_mode' put: theValue! !

!SatelliteSubsystem methodsFor: 'command' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 19:34'!
shortTelemetry
	| result |
	
	result := OrderedCollection new.
	
	shortTelemetryKeys do: [ :key | result add: (data associationAt: key)].
	
	^ DataCommandResponse newWithData: result
	
	
	
	! !

!SatelliteSubsystem methodsFor: 'command' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/29/2013 19:34'!
telemetry
	| result |
	
	result := OrderedCollection new.
	
	telemetryKeys do: [ :key | result add: (data associationAt: key)].
	
	^ DataCommandResponse newWithData: result! !

!SatelliteSubsystem methodsFor: 'accessing' stamp: 'EzequielDavidovichCaballero 9/29/2013 17:30'!
understands: aCommand
	^ (commands keys includes: aCommand).! !

Object subclass: #SequenceNumber
	instanceVariableNames: 'number lastNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-Satellite'!

SequenceNumber class
	instanceVariableNames: 'number'!

SequenceNumber class
	instanceVariableNames: 'number'!

!SequenceNumber class methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/20/2013 17:36'!
startingFrom: aNumber
	^ self new initializeWithStart: aNumber! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 19:08'!
asByteArray
	| resultSize resultBytes sequenceNumber start |

	resultSize := 3.

	resultBytes := ByteArray new: resultSize.
	
	sequenceNumber := number asByteArray.

	start := (resultSize - (sequenceNumber size) + 1).

	^ resultBytes replaceFrom: start to: resultSize with: sequenceNumber. 
! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/27/2013 12:55'!
bitAnd: aSmallInteger 
	^number bitAnd: aSmallInteger ! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EzequielDavidovichCaballero 9/27/2013 12:56'!
digitAt: aSmallInteger 
	^number bitAnd: aSmallInteger ! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 21:14'!
initialize
	number := 1.
	lastNumber := LargePositiveInteger readFrom: 'FFFFEF' base: 16.
! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 14:58'!
initializeWithStart: aNumber
	self initialize.
	number := aNumber.! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 14:53'!
next
	number := number + 1.
	number > lastNumber ifTrue: [ self reset. ].
	^ number.
! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 15:00'!
number
	^ number! !

!SequenceNumber methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielDavidovichCaballero 9/15/2013 14:52'!
reset
	number := 1.! !
